diff --git a/README.markdown b/README.markdown
index 135e8e5..5fd07ac 100644
--- a/README.markdown
+++ b/README.markdown
@@ -14,8 +14,11 @@ or Wget:
wget -qO- https://raw.github.com/creationix/nvm/master/install.sh | sh
-The script clones the nvm repository to `~/.nvm` and adds the source line to your profile (`~/.bash_profile` or `~/.profile`).
+The script clones the nvm repository to `~/.nvm` and adds the source line to your profile (`~/.bash_profile`, `~/.zshrc` or `~/.profile`).
+You can customize the install source, directory and profile using the `NVM_SOURCE`, `NVM_DIR` and `NVM_PROFILE` variables. Eg: `curl ... | NVM_DIR=/usr/local/nvm sh` for a global install.
+
+*NB. There is also a [gitless installer](https://github.com/creationix/nvm/blob/master/install-gitless.sh) available, which accepts the same variables as the default installer.*
### Manual install
diff --git a/install-gitless.sh b/install-gitless.sh
index d2ee6e6..8a3a27c 100755
--- a/install-gitless.sh
+++ b/install-gitless.sh
@@ -1,59 +1,59 @@
#!/bin/bash
-function fatalExit (){
- echo "$@" && exit 1;
-}
+set -e
-# an alternative URL that could be used: https://github.com/creationix/nvm/tarball/master
-if [ "$NVM_SOURCE" == "" ]; then
- NVM_SOURCE="https://raw.github.com/creationix/nvm/master/nvm.sh"
+if [ ! "$NVM_SOURCE" ]; then
+ NVM_SOURCE="https://raw.github.com/creationix/nvm/master/nvm.sh"
fi
-if [ "$NVM_DIR" == "" ]; then
- NVM_DIR="$HOME/.nvm"
+if [ ! "$NVM_DIR" ]; then
+ NVM_DIR="$HOME/.nvm"
fi
# Downloading to $NVM_DIR
mkdir -p "$NVM_DIR"
-pushd "$NVM_DIR" > /dev/null
-echo -ne "=> Downloading... "
-curl --silent "$NVM_SOURCE" -o nvm.sh || fatalExit "Failed";
+echo -e "\r=> Downloading... \c"
+curl --silent "$NVM_SOURCE" -o "$NVM_DIR/nvm.sh" || {
+ echo "Failed downloading $NVM_SOURCE" && exit 1
+}
echo "Downloaded"
-popd > /dev/null
-# Detect profile file, .bash_profile has precedence over .profile
-if [ ! -z "$1" ]; then
- PROFILE="$1"
-else
+echo
+
+# Detect profile file if not specified as environment variable (eg: PROFILE=~/.myprofile).
+if [ ! "$PROFILE" ]; then
if [ -f "$HOME/.bash_profile" ]; then
- PROFILE="$HOME/.bash_profile"
+ PROFILE="$HOME/.bash_profile"
+ elif [ -f "$HOME/.zshrc" ]; then
+ PROFILE="$HOME/.zshrc"
elif [ -f "$HOME/.profile" ]; then
- PROFILE="$HOME/.profile"
+ PROFILE="$HOME/.profile"
fi
fi
-SOURCE_STR="[[ -s "$NVM_DIR/nvm.sh" ]] && . "$NVM_DIR/nvm.sh" # This loads NVM"
+SOURCE_STR="[ -s \"$NVM_DIR/nvm.sh\" ] && . \"$NVM_DIR/nvm.sh\" # This loads NVM"
if [ -z "$PROFILE" ] || [ ! -f "$PROFILE" ] ; then
if [ -z $PROFILE ]; then
- echo "=> Profile not found"
+ echo "=> Profile not found. Tried ~/.bash_profile ~/.zshrc and ~/.profile."
+ echo "=> Create one of them and run this script again"
else
- echo "=> Profile $PROFILE not found"
+ echo "=> Profile $PROFILE not found"
+ echo "=> Create it (touch $PROFILE) and run this script again"
fi
- echo "=> Append the following line to the correct file yourself"
+ echo " OR"
+ echo "=> Append the following line to the correct file yourself:"
echo
- echo "\t$SOURCE_STR"
+ echo " $SOURCE_STR"
echo
- echo "=> Close and reopen your terminal to start using NVM"
- exit
-fi
-
-if ! grep -qc 'nvm.sh' $PROFILE; then
- echo "=> Appending source string to $PROFILE"
- echo "" >> "$PROFILE"
- echo $SOURCE_STR >> "$PROFILE"
else
- echo "=> Source string already in $PROFILE"
+ if ! grep -qc 'nvm.sh' $PROFILE; then
+ echo "=> Appending source string to $PROFILE"
+ echo "" >> "$PROFILE"
+ echo $SOURCE_STR >> "$PROFILE"
+ else
+ echo "=> Source string already in $PROFILE"
+ fi
fi
echo "=> Close and reopen your terminal to start using NVM"
diff --git a/install.sh b/install.sh
index 8117dca..94cb634 100755
--- a/install.sh
+++ b/install.sh
@@ -1,6 +1,14 @@
#!/bin/bash
-NVM_DIR="$HOME/.nvm"
+set -e
+
+if [ ! "$NVM_SOURCE" ]; then
+ NVM_SOURCE="https://github.com/creationix/nvm.git"
+fi
+
+if [ ! "$NVM_DIR" ]; then
+ NVM_DIR="$HOME/.nvm"
+fi
if ! hash git 2>/dev/null; then
echo >&2 "You need to install git - visit http://git-scm.com/downloads"
@@ -10,56 +18,50 @@ fi
if [ -d "$NVM_DIR" ]; then
echo "=> NVM is already installed in $NVM_DIR, trying to update"
- echo -ne "\r=> "
- cd $NVM_DIR && git pull
+ echo -e "\r=> \c"
+ cd "$NVM_DIR" && git pull
else
# Cloning to $NVM_DIR
- git clone https://github.com/creationix/nvm.git $NVM_DIR
+ mkdir -p "$NVM_DIR"
+ git clone "$NVM_SOURCE" "$NVM_DIR"
fi
echo
-# Detect profile file, .bash_profile has precedence over .profile
-if [ ! -z "$1" ]; then
- PROFILE="$1"
-else
+# Detect profile file if not specified as environment variable (eg: PROFILE=~/.myprofile).
+if [ ! "$PROFILE" ]; then
if [ -f "$HOME/.bash_profile" ]; then
- PROFILE="$HOME/.bash_profile"
+ PROFILE="$HOME/.bash_profile"
elif [ -f "$HOME/.zshrc" ]; then
- PROFILE="$HOME/.zshrc"
+ PROFILE="$HOME/.zshrc"
elif [ -f "$HOME/.profile" ]; then
- PROFILE="$HOME/.profile"
+ PROFILE="$HOME/.profile"
fi
fi
-SOURCE_STR="[ -s \$HOME/.nvm/nvm.sh ] && . \$HOME/.nvm/nvm.sh # This loads NVM"
+SOURCE_STR="[ -s \"$NVM_DIR/nvm.sh\" ] && . \"$NVM_DIR/nvm.sh\" # This loads NVM"
if [ -z "$PROFILE" ] || [ ! -f "$PROFILE" ] ; then
if [ -z $PROFILE ]; then
- echo "=> Profile not found. Tried $HOME/.bash_profile and $HOME/.profile"
+ echo "=> Profile not found. Tried ~/.bash_profile ~/.zshrc and ~/.profile."
+ echo "=> Create one of them and run this script again"
else
- echo "=> Profile $PROFILE not found"
+ echo "=> Profile $PROFILE not found"
+ echo "=> Create it (touch $PROFILE) and run this script again"
fi
- echo "=> Run this script again after running the following:"
+ echo " OR"
+ echo "=> Append the following line to the correct file yourself:"
echo
- echo "\ttouch $HOME/.profile"
+ echo " $SOURCE_STR"
echo
- echo "-- OR --"
- echo
- echo "=> Append the following line to the correct file yourself"
- echo
- echo "\t$SOURCE_STR"
- echo
- echo "=> Close and reopen your terminal afterwards to start using NVM"
- exit
-fi
-
-if ! grep -qc 'nvm.sh' $PROFILE; then
- echo "=> Appending source string to $PROFILE"
- echo "" >> "$PROFILE"
- echo $SOURCE_STR >> "$PROFILE"
else
- echo "=> Source string already in $PROFILE"
+ if ! grep -qc 'nvm.sh' $PROFILE; then
+ echo "=> Appending source string to $PROFILE"
+ echo "" >> "$PROFILE"
+ echo $SOURCE_STR >> "$PROFILE"
+ else
+ echo "=> Source string already in $PROFILE"
+ fi
fi
echo "=> Close and reopen your terminal to start using NVM"